import React from 'react';
import ReactDOM from 'react-dom';

import { App } from './App.js';
import { StateTree } from './StateTree.js';
import { GET } from './xhr.js';

window.initApp = function(data)
{
    const st = new StateTree({
        doQuery: (cb) =>
        {
            GET('/data', {}, (r, d) =>
            {
                cb(d);
            });
        },
    });
    if (data)
    {
        st.import(data);
    }
    ReactDOM.hydrate(
        <App state={st} />, document.getElementById('app')
    );
};
