require("babel-register")({
    ignore: /node_modules/,
    presets: [ [ "env", { "targets": { "node": "current" }, "exclude": [ "transform-regenerator" ] } ], "stage-1", "react" ],
    retainLines: true
});

const hook = require('css-modules-require-hook');

hook({
    generateScopedName: '[name]--[local]--[hash:base64:8]',
});

const fs = require('fs');
const SSRServer = require('./Server.js').SSRServer;

var options;
if (process.argv.length > 2)
{
    options = JSON.parse(fs.readFileSync(process.argv[2], { encoding: 'utf-8' }));
}
new SSRServer().start(options);
